require '_h2ph_pre.ph';

unless(defined(&__ASM_MSR_H)) {
    eval 'sub __ASM_MSR_H () {1;}' unless defined(&__ASM_MSR_H);
    eval 'sub rdmsr {
        local($msr,$val1,$val2) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdmsr\\" : \\"=a\\" ($val1), \\"=d\\" ($val2) : \\"c\\" ($msr)));
    }' unless defined(&rdmsr);
    eval 'sub wrmsr {
        local($msr,$val1,$val2) = @_;
	    eval q( &__asm__  &__volatile__(\\"wrmsr\\" : : \\"c\\" ($msr), \\"a\\" ($val1), \\"d\\" ($val2)));
    }' unless defined(&wrmsr);
    eval 'sub rdtsc {
        local($low,$high) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=a\\" ($low), \\"=d\\" ($high)));
    }' unless defined(&rdtsc);
    eval 'sub rdtscl {
        local($low) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=a\\" ($low) : : \\"edx\\"));
    }' unless defined(&rdtscl);
    eval 'sub rdtscll {
        local($val) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=A\\" ($val)));
    }' unless defined(&rdtscll);
    eval 'sub write_tsc {
        local($val1,$val2) = @_;
	    eval q( &wrmsr(0x10, $val1, $val2));
    }' unless defined(&write_tsc);
    eval 'sub rdpmc {
        local($counter,$low,$high) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdpmc\\" : \\"=a\\" ($low), \\"=d\\" ($high) : \\"c\\" ($counter)));
    }' unless defined(&rdpmc);
    eval 'sub MSR_IA32_P5_MC_ADDR () {0;}' unless defined(&MSR_IA32_P5_MC_ADDR);
    eval 'sub MSR_IA32_P5_MC_TYPE () {1;}' unless defined(&MSR_IA32_P5_MC_TYPE);
    eval 'sub MSR_IA32_PLATFORM_ID () {0x17;}' unless defined(&MSR_IA32_PLATFORM_ID);
    eval 'sub MSR_IA32_EBL_CR_POWERON () {0x2a;}' unless defined(&MSR_IA32_EBL_CR_POWERON);
    eval 'sub MSR_IA32_APICBASE () {0x1b;}' unless defined(&MSR_IA32_APICBASE);
    eval 'sub MSR_IA32_APICBASE_BSP () {(1<<8);}' unless defined(&MSR_IA32_APICBASE_BSP);
    eval 'sub MSR_IA32_APICBASE_ENABLE () {(1<<11);}' unless defined(&MSR_IA32_APICBASE_ENABLE);
    eval 'sub MSR_IA32_APICBASE_BASE () {(0xfffff<<12);}' unless defined(&MSR_IA32_APICBASE_BASE);
    eval 'sub MSR_IA32_UCODE_WRITE () {0x79;}' unless defined(&MSR_IA32_UCODE_WRITE);
    eval 'sub MSR_IA32_UCODE_REV () {0x8b;}' unless defined(&MSR_IA32_UCODE_REV);
    eval 'sub MSR_IA32_PERFCTR0 () {0xc1;}' unless defined(&MSR_IA32_PERFCTR0);
    eval 'sub MSR_IA32_PERFCTR1 () {0xc2;}' unless defined(&MSR_IA32_PERFCTR1);
    eval 'sub MSR_IA32_BBL_CR_CTL () {0x119;}' unless defined(&MSR_IA32_BBL_CR_CTL);
    eval 'sub MSR_IA32_MCG_CAP () {0x179;}' unless defined(&MSR_IA32_MCG_CAP);
    eval 'sub MSR_IA32_MCG_STATUS () {0x17a;}' unless defined(&MSR_IA32_MCG_STATUS);
    eval 'sub MSR_IA32_MCG_CTL () {0x17b;}' unless defined(&MSR_IA32_MCG_CTL);
    eval 'sub MSR_IA32_EVNTSEL0 () {0x186;}' unless defined(&MSR_IA32_EVNTSEL0);
    eval 'sub MSR_IA32_EVNTSEL1 () {0x187;}' unless defined(&MSR_IA32_EVNTSEL1);
    eval 'sub MSR_IA32_DEBUGCTLMSR () {0x1d9;}' unless defined(&MSR_IA32_DEBUGCTLMSR);
    eval 'sub MSR_IA32_LASTBRANCHFROMIP () {0x1db;}' unless defined(&MSR_IA32_LASTBRANCHFROMIP);
    eval 'sub MSR_IA32_LASTBRANCHTOIP () {0x1dc;}' unless defined(&MSR_IA32_LASTBRANCHTOIP);
    eval 'sub MSR_IA32_LASTINTFROMIP () {0x1dd;}' unless defined(&MSR_IA32_LASTINTFROMIP);
    eval 'sub MSR_IA32_LASTINTTOIP () {0x1de;}' unless defined(&MSR_IA32_LASTINTTOIP);
    eval 'sub MSR_IA32_MC0_CTL () {0x400;}' unless defined(&MSR_IA32_MC0_CTL);
    eval 'sub MSR_IA32_MC0_STATUS () {0x401;}' unless defined(&MSR_IA32_MC0_STATUS);
    eval 'sub MSR_IA32_MC0_ADDR () {0x402;}' unless defined(&MSR_IA32_MC0_ADDR);
    eval 'sub MSR_IA32_MC0_MISC () {0x403;}' unless defined(&MSR_IA32_MC0_MISC);
    eval 'sub MSR_K6_EFER () {0xc0000080;}' unless defined(&MSR_K6_EFER);
    eval 'sub MSR_K6_STAR () {0xc0000081;}' unless defined(&MSR_K6_STAR);
    eval 'sub MSR_K6_WHCR () {0xc0000082;}' unless defined(&MSR_K6_WHCR);
    eval 'sub MSR_K6_UWCCR () {0xc0000085;}' unless defined(&MSR_K6_UWCCR);
    eval 'sub MSR_K6_PSOR () {0xc0000087;}' unless defined(&MSR_K6_PSOR);
    eval 'sub MSR_K6_PFIR () {0xc0000088;}' unless defined(&MSR_K6_PFIR);
    eval 'sub MSR_K7_EVNTSEL0 () {0xc0010000;}' unless defined(&MSR_K7_EVNTSEL0);
    eval 'sub MSR_K7_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_K7_PERFCTR0);
    eval 'sub MSR_IDT_FCR1 () {0x107;}' unless defined(&MSR_IDT_FCR1);
    eval 'sub MSR_IDT_FCR2 () {0x108;}' unless defined(&MSR_IDT_FCR2);
    eval 'sub MSR_IDT_FCR3 () {0x109;}' unless defined(&MSR_IDT_FCR3);
    eval 'sub MSR_IDT_FCR4 () {0x10a;}' unless defined(&MSR_IDT_FCR4);
    eval 'sub MSR_IDT_MCR0 () {0x110;}' unless defined(&MSR_IDT_MCR0);
    eval 'sub MSR_IDT_MCR1 () {0x111;}' unless defined(&MSR_IDT_MCR1);
    eval 'sub MSR_IDT_MCR2 () {0x112;}' unless defined(&MSR_IDT_MCR2);
    eval 'sub MSR_IDT_MCR3 () {0x113;}' unless defined(&MSR_IDT_MCR3);
    eval 'sub MSR_IDT_MCR4 () {0x114;}' unless defined(&MSR_IDT_MCR4);
    eval 'sub MSR_IDT_MCR5 () {0x115;}' unless defined(&MSR_IDT_MCR5);
    eval 'sub MSR_IDT_MCR6 () {0x116;}' unless defined(&MSR_IDT_MCR6);
    eval 'sub MSR_IDT_MCR7 () {0x117;}' unless defined(&MSR_IDT_MCR7);
    eval 'sub MSR_IDT_MCR_CTRL () {0x120;}' unless defined(&MSR_IDT_MCR_CTRL);
    eval 'sub MSR_VIA_FCR () {0x1107;}' unless defined(&MSR_VIA_FCR);
}
1;
