require '_h2ph_pre.ph';

unless(defined(&_LINUX_ACPI_H)) {
    eval 'sub _LINUX_ACPI_H () {1;}' unless defined(&_LINUX_ACPI_H);
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/sched.ph';
	require 'linux/wait.ph';
    }
    eval 'sub ACPI_BIOS_ROM_BASE () {(0x0e0000);}' unless defined(&ACPI_BIOS_ROM_BASE);
    eval 'sub ACPI_BIOS_ROM_END () {(0x100000);}' unless defined(&ACPI_BIOS_ROM_END);
    eval 'sub ACPI_RSDP1_SIG () {0x20445352;}' unless defined(&ACPI_RSDP1_SIG);
    eval 'sub ACPI_RSDP2_SIG () {0x20525450;}' unless defined(&ACPI_RSDP2_SIG);
    eval 'sub ACPI_RSDT_SIG () {0x54445352;}' unless defined(&ACPI_RSDT_SIG);
    eval 'sub ACPI_FADT_SIG () {0x50434146;}' unless defined(&ACPI_FADT_SIG);
    eval 'sub ACPI_DSDT_SIG () {0x54445344;}' unless defined(&ACPI_DSDT_SIG);
    eval 'sub ACPI_FACS_SIG () {0x53434146;}' unless defined(&ACPI_FACS_SIG);
    eval 'sub ACPI_SIG_LEN () {4;}' unless defined(&ACPI_SIG_LEN);
    eval 'sub ACPI_FADT_SIGNATURE () {"FACP";}' unless defined(&ACPI_FADT_SIGNATURE);
    eval 'sub ACPI_TMR () {0x0001;}' unless defined(&ACPI_TMR);
    eval 'sub ACPI_BM () {0x0010;}' unless defined(&ACPI_BM);
    eval 'sub ACPI_GBL () {0x0020;}' unless defined(&ACPI_GBL);
    eval 'sub ACPI_PWRBTN () {0x0100;}' unless defined(&ACPI_PWRBTN);
    eval 'sub ACPI_SLPBTN () {0x0200;}' unless defined(&ACPI_SLPBTN);
    eval 'sub ACPI_RTC () {0x0400;}' unless defined(&ACPI_RTC);
    eval 'sub ACPI_WAK () {0x8000;}' unless defined(&ACPI_WAK);
    eval 'sub ACPI_SCI_EN () {0x0001;}' unless defined(&ACPI_SCI_EN);
    eval 'sub ACPI_BM_RLD () {0x0002;}' unless defined(&ACPI_BM_RLD);
    eval 'sub ACPI_GBL_RLS () {0x0004;}' unless defined(&ACPI_GBL_RLS);
    eval 'sub ACPI_SLP_TYP0 () {0x0400;}' unless defined(&ACPI_SLP_TYP0);
    eval 'sub ACPI_SLP_TYP1 () {0x0800;}' unless defined(&ACPI_SLP_TYP1);
    eval 'sub ACPI_SLP_TYP2 () {0x1000;}' unless defined(&ACPI_SLP_TYP2);
    eval 'sub ACPI_SLP_EN () {0x2000;}' unless defined(&ACPI_SLP_EN);
    eval 'sub ACPI_SLP_TYP_MASK () {0x1c00;}' unless defined(&ACPI_SLP_TYP_MASK);
    eval 'sub ACPI_SLP_TYP_SHIFT () {10;}' unless defined(&ACPI_SLP_TYP_SHIFT);
    eval 'sub ACPI_TMR_VAL_EXT () {0x00000100;}' unless defined(&ACPI_TMR_VAL_EXT);
    eval 'sub ACPI_TMR_MASK () {0x00ffffff;}' unless defined(&ACPI_TMR_MASK);
    eval 'sub ACPI_TMR_HZ () {3579545;}' unless defined(&ACPI_TMR_HZ);
    eval 'sub ACPI_TMR_KHZ () {( &ACPI_TMR_HZ / 1000);}' unless defined(&ACPI_TMR_KHZ);
    eval 'sub ACPI_MICROSEC_TO_TMR_TICKS {
        local($val) = @_;
	    eval q(((($val) * ( &ACPI_TMR_KHZ)) / 1000));
    }' unless defined(&ACPI_MICROSEC_TO_TMR_TICKS);
    eval 'sub ACPI_ARB_DIS () {0x01;}' unless defined(&ACPI_ARB_DIS);
    eval 'sub ACPI_WBINVD () {0x00000001;}' unless defined(&ACPI_WBINVD);
    eval 'sub ACPI_WBINVD_FLUSH () {0x00000002;}' unless defined(&ACPI_WBINVD_FLUSH);
    eval 'sub ACPI_PROC_C1 () {0x00000004;}' unless defined(&ACPI_PROC_C1);
    eval 'sub ACPI_P_LVL2_UP () {0x00000008;}' unless defined(&ACPI_P_LVL2_UP);
    eval 'sub ACPI_PWR_BUTTON () {0x00000010;}' unless defined(&ACPI_PWR_BUTTON);
    eval 'sub ACPI_SLP_BUTTON () {0x00000020;}' unless defined(&ACPI_SLP_BUTTON);
    eval 'sub ACPI_FIX_RTC () {0x00000040;}' unless defined(&ACPI_FIX_RTC);
    eval 'sub ACPI_RTC_64 () {0x00000080;}' unless defined(&ACPI_RTC_64);
    eval 'sub ACPI_TMR_VAL_EXT () {0x00000100;}' unless defined(&ACPI_TMR_VAL_EXT);
    eval 'sub ACPI_DCK_CAP () {0x00000200;}' unless defined(&ACPI_DCK_CAP);
    eval 'sub FADT_BOOT_ARCH_LEGACY_DEVICES () {0x0001;}' unless defined(&FADT_BOOT_ARCH_LEGACY_DEVICES);
    eval 'sub FADT_BOOT_ARCH_KBD_CONTROLLER () {0x0002;}' unless defined(&FADT_BOOT_ARCH_KBD_CONTROLLER);
    eval 'sub ACPI_S4BIOS () {0x00000001;}' unless defined(&ACPI_S4BIOS);
    eval 'sub ACPI_P_CNT () {0x00000000;}' unless defined(&ACPI_P_CNT);
    eval 'sub ACPI_P_LVL2 () {0x00000004;}' unless defined(&ACPI_P_LVL2);
    eval 'sub ACPI_P_LVL3 () {0x00000005;}' unless defined(&ACPI_P_LVL3);
    eval 'sub ACPI_MAX_P_LVL2_LAT () {100;}' unless defined(&ACPI_MAX_P_LVL2_LAT);
    eval 'sub ACPI_MAX_P_LVL3_LAT () {1000;}' unless defined(&ACPI_MAX_P_LVL3_LAT);
    eval 'sub ACPI_INFINITE_LAT () {(~0);}' unless defined(&ACPI_INFINITE_LAT);
    eval 'sub ACPI_SLP_TYP_DISABLED () {(~0);}' unless defined(&ACPI_SLP_TYP_DISABLED);
}
1;
