require '_h2ph_pre.ph';

unless(defined(&_LINUX_MM_H)) {
    eval 'sub _LINUX_MM_H () {1;}' unless defined(&_LINUX_MM_H);
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/string.ph';
	require 'linux/list.ph';
	require 'linux/mmzone.ph';
	require 'linux/swap.ph';
	require 'asm/page.ph';
	require 'asm/pgtable.ph';
	require 'asm/atomic.ph';
	require 'asm/resource.ph';
	eval 'sub VM_READ () {0x00000001;}' unless defined(&VM_READ);
	eval 'sub VM_WRITE () {0x00000002;}' unless defined(&VM_WRITE);
	eval 'sub VM_EXEC () {0x00000004;}' unless defined(&VM_EXEC);
	eval 'sub VM_SHARED () {0x00000008;}' unless defined(&VM_SHARED);
	eval 'sub VM_MAYREAD () {0x00000010;}' unless defined(&VM_MAYREAD);
	eval 'sub VM_MAYWRITE () {0x00000020;}' unless defined(&VM_MAYWRITE);
	eval 'sub VM_MAYEXEC () {0x00000040;}' unless defined(&VM_MAYEXEC);
	eval 'sub VM_MAYSHARE () {0x00000080;}' unless defined(&VM_MAYSHARE);
	eval 'sub VM_GROWSDOWN () {0x00000100;}' unless defined(&VM_GROWSDOWN);
	eval 'sub VM_GROWSUP () {0x00000200;}' unless defined(&VM_GROWSUP);
	eval 'sub VM_SHM () {0x00000400;}' unless defined(&VM_SHM);
	eval 'sub VM_DENYWRITE () {0x00000800;}' unless defined(&VM_DENYWRITE);
	eval 'sub VM_EXECUTABLE () {0x00001000;}' unless defined(&VM_EXECUTABLE);
	eval 'sub VM_LOCKED () {0x00002000;}' unless defined(&VM_LOCKED);
	eval 'sub VM_IO () {0x00004000;}' unless defined(&VM_IO);
	eval 'sub VM_SEQ_READ () {0x00008000;}' unless defined(&VM_SEQ_READ);
	eval 'sub VM_RAND_READ () {0x00010000;}' unless defined(&VM_RAND_READ);
	eval 'sub VM_DONTCOPY () {0x00020000;}' unless defined(&VM_DONTCOPY);
	eval 'sub VM_DONTEXPAND () {0x00040000;}' unless defined(&VM_DONTEXPAND);
	eval 'sub VM_RESERVED () {0x00080000;}' unless defined(&VM_RESERVED);
	eval 'sub VM_BIGPAGE () {0x00100000;}' unless defined(&VM_BIGPAGE);
	eval 'sub VM_BIGMAP () {0x00200000;}' unless defined(&VM_BIGMAP);
	eval 'sub VM_STACK_FLAGS () {0x00000177;}' unless defined(&VM_STACK_FLAGS);
	eval 'sub VM_READHINTMASK () {( &VM_SEQ_READ |  &VM_RAND_READ);}' unless defined(&VM_READHINTMASK);
	eval 'sub VM_ClearReadHint {
	    local($v) = @_;
    	    eval q(($v)-> &vm_flags &= ~ &VM_READHINTMASK);
	}' unless defined(&VM_ClearReadHint);
	eval 'sub VM_NormalReadHint {
	    local($v) = @_;
    	    eval q((!(($v)-> &vm_flags &  &VM_READHINTMASK)));
	}' unless defined(&VM_NormalReadHint);
	eval 'sub VM_SequentialReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_SEQ_READ));
	}' unless defined(&VM_SequentialReadHint);
	eval 'sub VM_RandomReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_RAND_READ));
	}' unless defined(&VM_RandomReadHint);
	eval 'sub get_page {
	    local($p) = @_;
    	    eval q( &atomic_inc(($p)-> &count));
	}' unless defined(&get_page);
	eval 'sub put_page {
	    local($p) = @_;
    	    eval q( &__free_page($p));
	}' unless defined(&put_page);
	eval 'sub put_page_testzero {
	    local($p) = @_;
    	    eval q( &atomic_dec_and_test(($p)-> &count));
	}' unless defined(&put_page_testzero);
	eval 'sub page_count {
	    local($p) = @_;
    	    eval q( &atomic_read(($p)-> &count));
	}' unless defined(&page_count);
	eval 'sub set_page_count {
	    local($p,$v) = @_;
    	    eval q( &atomic_set(($p)-> &count, $v));
	}' unless defined(&set_page_count);
	eval 'sub PG_locked () {0;}' unless defined(&PG_locked);
	eval 'sub PG_error () {1;}' unless defined(&PG_error);
	eval 'sub PG_referenced () {2;}' unless defined(&PG_referenced);
	eval 'sub PG_uptodate () {3;}' unless defined(&PG_uptodate);
	eval 'sub PG_dirty () {4;}' unless defined(&PG_dirty);
	eval 'sub PG_unused_1 () {5;}' unless defined(&PG_unused_1);
	eval 'sub PG_active () {6;}' unless defined(&PG_active);
	eval 'sub PG_inactive_dirty () {7;}' unless defined(&PG_inactive_dirty);
	eval 'sub PG_slab () {8;}' unless defined(&PG_slab);
	eval 'sub PG_swap_cache () {9;}' unless defined(&PG_swap_cache);
	eval 'sub PG_skip () {10;}' unless defined(&PG_skip);
	eval 'sub PG_inactive_clean () {11;}' unless defined(&PG_inactive_clean);
	eval 'sub PG_highmem () {12;}' unless defined(&PG_highmem);
	eval 'sub PG_checked () {13;}' unless defined(&PG_checked);
	eval 'sub PG_bigpage () {14;}' unless defined(&PG_bigpage);
	eval 'sub PG_arch_1 () {30;}' unless defined(&PG_arch_1);
	eval 'sub PG_reserved () {31;}' unless defined(&PG_reserved);
	eval 'sub Page_Uptodate {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&Page_Uptodate);
	eval 'sub SetPageUptodate {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&SetPageUptodate);
	eval 'sub ClearPageUptodate {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&ClearPageUptodate);
	eval 'sub PageDirty {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&PageDirty);
	eval 'sub SetPageDirty {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&SetPageDirty);
	eval 'sub ClearPageDirty {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&ClearPageDirty);
	eval 'sub PageLocked {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&PageLocked);
	eval 'sub LockPage {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&LockPage);
	eval 'sub TryLockPage {
	    local($page) = @_;
    	    eval q( &test_and_set_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&TryLockPage);
	eval 'sub PageChecked {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_checked, ($page)-> &flags));
	}' unless defined(&PageChecked);
	eval 'sub SetPageChecked {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_checked, ($page)-> &flags));
	}' unless defined(&SetPageChecked);
	eval 'sub BigPage {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_bigpage, ($page)-> &flags));
	}' unless defined(&BigPage);
	eval 'sub UnlockPage {
	    local($page) = @_;
    	    eval q( &do {  &smp_mb__before_clear_bit();  &if (! &test_and_clear_bit( &PG_locked, ($page)-> &flags))  &BUG();  &smp_mb__after_clear_bit();  &if ( &waitqueue_active(($page)-> &wait))  &wake_up(($page)-> &wait); }  &while (0));
	}' unless defined(&UnlockPage);
	eval 'sub PageError {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&PageError);
	eval 'sub SetPageError {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&SetPageError);
	eval 'sub ClearPageError {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&ClearPageError);
	eval 'sub PageReferenced {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&PageReferenced);
	eval 'sub SetPageReferenced {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&SetPageReferenced);
	eval 'sub ClearPageReferenced {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&ClearPageReferenced);
	eval 'sub PageTestandClearReferenced {
	    local($page) = @_;
    	    eval q( &test_and_clear_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&PageTestandClearReferenced);
	eval 'sub PageSlab {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageSlab);
	eval 'sub PageSwapCache {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageSwapCache);
	eval 'sub PageReserved {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&PageReserved);
	eval 'sub PageSetSlab {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageSetSlab);
	eval 'sub PageSetSwapCache {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageSetSwapCache);
	eval 'sub PageTestandSetSwapCache {
	    local($page) = @_;
    	    eval q( &test_and_set_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageTestandSetSwapCache);
	eval 'sub PageClearSlab {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageClearSlab);
	eval 'sub PageClearSwapCache {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageClearSwapCache);
	eval 'sub PageTestandClearSwapCache {
	    local($page) = @_;
    	    eval q( &test_and_clear_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageTestandClearSwapCache);
	eval 'sub PageActive {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_active, ($page)-> &flags));
	}' unless defined(&PageActive);
	eval 'sub SetPageActive {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_active, ($page)-> &flags));
	}' unless defined(&SetPageActive);
	eval 'sub ClearPageActive {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_active, ($page)-> &flags));
	}' unless defined(&ClearPageActive);
	eval 'sub PageInactiveDirty {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_inactive_dirty, ($page)-> &flags));
	}' unless defined(&PageInactiveDirty);
	eval 'sub SetPageInactiveDirty {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_inactive_dirty, ($page)-> &flags));
	}' unless defined(&SetPageInactiveDirty);
	eval 'sub ClearPageInactiveDirty {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_inactive_dirty, ($page)-> &flags));
	}' unless defined(&ClearPageInactiveDirty);
	eval 'sub PageInactiveClean {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_inactive_clean, ($page)-> &flags));
	}' unless defined(&PageInactiveClean);
	eval 'sub SetPageInactiveClean {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_inactive_clean, ($page)-> &flags));
	}' unless defined(&SetPageInactiveClean);
	eval 'sub ClearPageInactiveClean {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_inactive_clean, ($page)-> &flags));
	}' unless defined(&ClearPageInactiveClean);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub PageHighMem {
	        local($page) = @_;
    		eval q( &test_bit( &PG_highmem, ($page)-> &flags));
	    }' unless defined(&PageHighMem);
	} else {
	    eval 'sub PageHighMem {
	        local($page) = @_;
    		eval q(0);
	    }' unless defined(&PageHighMem);
	}
	eval 'sub SetPageReserved {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&SetPageReserved);
	eval 'sub ClearPageReserved {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&ClearPageReserved);
	eval 'sub NOPAGE_SIGBUS () {( &NULL);}' unless defined(&NOPAGE_SIGBUS);
	eval 'sub NOPAGE_OOM () {( (-1));}' unless defined(&NOPAGE_OOM);
	eval 'sub alloc_page {
	    local($gfp_mask) = @_;
    	    eval q( &alloc_pages($gfp_mask, 0));
	}' unless defined(&alloc_page);
	eval 'sub __get_free_page {
	    local($gfp_mask) = @_;
    	    eval q( &__get_free_pages(($gfp_mask),0));
	}' unless defined(&__get_free_page);
	eval 'sub __get_dma_pages {
	    local($gfp_mask, $order) = @_;
    	    eval q( &__get_free_pages(($gfp_mask) |  &GFP_DMA,($order)));
	}' unless defined(&__get_dma_pages);
	eval 'sub get_free_page () { &get_zeroed_page;}' unless defined(&get_free_page);
	eval 'sub __free_page {
	    local($page) = @_;
    	    eval q( &__free_pages(($page), 0));
	}' unless defined(&__free_page);
	eval 'sub free_page {
	    local($addr) = @_;
    	    eval q( &free_pages(($addr),0));
	}' unless defined(&free_page);
	eval 'sub __GFP_DMA () {0x01;}' unless defined(&__GFP_DMA);
	eval 'sub __GFP_HIGHMEM () {0x02;}' unless defined(&__GFP_HIGHMEM);
	eval 'sub __GFP_WAIT () {0x10;}' unless defined(&__GFP_WAIT);
	eval 'sub __GFP_HIGH () {0x20;}' unless defined(&__GFP_HIGH);
	eval 'sub __GFP_IO () {0x40;}' unless defined(&__GFP_IO);
	eval 'sub __GFP_FS () {0x80;}' unless defined(&__GFP_FS);
	eval 'sub GFP_NOIO () {( &__GFP_HIGH |  &__GFP_WAIT);}' unless defined(&GFP_NOIO);
	eval 'sub GFP_NOFS () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_NOFS);
	eval 'sub GFP_ATOMIC () {( &__GFP_HIGH);}' unless defined(&GFP_ATOMIC);
	eval 'sub GFP_USER () {(  &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS);}' unless defined(&GFP_USER);
	eval 'sub GFP_HIGHUSER () {(  &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS |  &__GFP_HIGHMEM);}' unless defined(&GFP_HIGHUSER);
	eval 'sub GFP_KERNEL () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS);}' unless defined(&GFP_KERNEL);
	eval 'sub GFP_NFS () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO |  &__GFP_FS);}' unless defined(&GFP_NFS);
	eval 'sub GFP_KSWAPD () {(  &__GFP_IO |  &__GFP_FS);}' unless defined(&GFP_KSWAPD);
	eval 'sub GFP_DMA () { &__GFP_DMA;}' unless defined(&GFP_DMA);
	unless(defined(&min)) {
	    eval 'sub min {
	        local($a,$b) = @_;
    		eval q(((($a)<($b))?($a):($b)));
	    }' unless defined(&min);
	    eval 'sub FOO_MIN () {1;}' unless defined(&FOO_MIN);
	}
	unless(defined(&max)) {
	    eval 'sub max {
	        local($a,$b) = @_;
    		eval q(((($a)>($b))?($a):($b)));
	    }' unless defined(&max);
	    eval 'sub FOO_MAX () {1;}' unless defined(&FOO_MAX);
	}
	eval 'sub PLENTY_FACTOR () {2;}' unless defined(&PLENTY_FACTOR);
	eval 'sub ALL_ZONES () { &NULL;}' unless defined(&ALL_ZONES);
	eval 'sub ANY_ZONE () {(~0);}' unless defined(&ANY_ZONE);
	eval 'sub INACTIVE_FACTOR () {5;}' unless defined(&INACTIVE_FACTOR);
	eval 'sub VM_MIN () {0;}' unless defined(&VM_MIN);
	eval 'sub VM_LOW () {1;}' unless defined(&VM_LOW);
	eval 'sub VM_HIGH () {2;}' unless defined(&VM_HIGH);
	eval 'sub VM_PLENTY () {3;}' unless defined(&VM_PLENTY);
	if(defined(&FOO_MIN)) {
	    undef(&min) if defined(&min);
	}
	if(defined(&FOO_MAX)) {
	    undef(&max) if defined(&max);
	}
	eval 'sub nFASTCALL {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&nFASTCALL);
    }
}
1;
